## ubuntu-terminal-app 0.7.218

=== src/app/CMakeLists.txt ===
file(GLOB_RECURSE QML_SRCS *.qml *.js *.json)

set(terminal_SRCS
    main.cpp
    fileio.cpp
    ${QML_SRCS}
)

add_executable(terminal ${terminal_SRCS})

qt5_use_modules(terminal Gui Qml Quick Widgets)

if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
add_custom_target(terminal-qmlfiles ALL
    COMMAND cp -r ${CMAKE_CURRENT_SOURCE_DIR}/qml ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${QMLFILES}
)
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

install(DIRECTORY qml DESTINATION ${DATA_DIR})
if(CLICK_MODE)
  install(TARGETS terminal DESTINATION ${BIN_DIR})
else()
  install(TARGETS terminal RUNTIME DESTINATION bin)
endif()

## ubuntu-terminal-app 0.7.216

=== debian/changelog ===
ubuntu-terminal-app (0.7.216) yakkety; urgency=medium

  * Get packaging ready for inclusion in yakkety (LP: #1623845, #1626457)
  * Update standards version
  * Fix up build dependency formatting
  * Added manpage
  * Update copyright
  * Update Vcs-bzr field
  * Adjust version to be similar to as used in the snap

  [ Michael Sheldon ]
  * Use dh_python3
  * Rename QML modules to new qml-module format.

  [ Larry Price ]
  * Add runtime dependency for qml-module-qt-labs-settings package.
  * Update QMLTermWidget to latest version and remove duplicate konsole
    application code.

 -- Luke Yelavich <themuso@ubuntu.com>  Wed, 28 Sep 2016 12:43:59 +1000

ubuntu-terminal-app (0.7) wily; urgency=medium

  * Bumped changelog version (LP: #1468385)

 -- David Planella <david.planella@ubuntu.com>  Sat, 04 Jul 2015 10:39:05 +0200

ubuntu-terminal-app (0.5ubuntu2) trusty; urgency=medium

  [ Alan Pope ]
  * Add -qt5 command line option (LP: #1288885)  

  [ David Planella ]
  * Merge konsole plugin into the app's repo. 

 -- David Planella <david.planella@ubuntu.com>  Sun, 27 Apr 2014 12:08:04 +0200

ubuntu-terminal-app (0.5) raring; urgency=low

  * Added landscape mode
  * Fixed click effect on Circle Menu

 -- Dmitry Zagnoyko <hiroshidi@gmail.com>  Fri, 24 May 2013 19:07:40 +0300

ubuntu-terminal-app (0.4) raring; urgency=low

  * Widget uses only available space
  * Widget scrolling replaced with swipe gestures
  * Added double tap for autocomplete
  * Added circle menu (test ver., aliases for CTRL+<key>)

 -- Dmitry Zagnoyko <hiroshidi@gmail.com>  Mon, 20 May 2013 12:52:01 +0300

ubuntu-terminal-app (0.3) raring; urgency=low

  * Added swipe gesture
  * Added extra keys panels
  * Sync with latest plugin revision

 -- Michael Hall <mhall119@ubuntu.com>  Mon, 06 May 2013 16:52:17 -0400

ubuntu-terminal-app (0.2) raring; urgency=low

  * Use Konsole plugin
  * Add Settings tab for color scheme and font size

 -- Michael Hall <mhall119@ubuntu.com>  Tue, 30 Apr 2013 21:28:16 -0400

ubuntu-terminal-app (0.1) raring; urgency=low

  * Initial release

 -- Michael Hall <mhall119@ubuntu.com>  Mon, 11 Feb 2013 16:04:00 -0500

=== debian/control ===
Source: ubuntu-terminal-app
Priority: extra
Maintainer: Ubuntu App Cats <ubuntu-touch-coreapps@lists.launchpad.net>
Build-Depends: cmake,
               debhelper (>= 9),
               dh-python,
               python3-all,
               gettext,
               intltool,
               libpam0g-dev,
               qtbase5-dev,
               qtdeclarative5-dev,
               qt5-default
Standards-Version: 3.9.8
Section: misc
Homepage: https://launchpad.net/ubuntu-terminal-app
Vcs-Bzr: https://code.launchpad.net/~ubuntu-terminal-dev/ubuntu-terminal-app/reboot

Package: ubuntu-terminal-app
Section: misc
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qmltermwidget1.0,
         qml-module-pamauthentication0.1,
         qml-module-qtquick2,
         qml-module-ubuntu-components,
         qml-module-qt-labs-settings,
         qml-module-qtsysteminfo (>= 5.0~),
Description: Terminal application
 Core Terminal application

Package: qml-module-qmltermwidget1.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${misc:Pre-Depends},
Description: QMLTermWidget QML plugin.
 This package contains the QMLTermWidget terminal emulator plugin
 for Qt Qml.

Package: qml-module-pamauthentication0.1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${misc:Pre-Depends},
Description: PAM authentication QML plugin
 This package contains a plugin that enables QML apps to do
 password authentication via the PAM API.

Package: ubuntu-terminal-app-autopilot
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
         libautopilot-qt,
         libqt5test5,
         python3-autopilot,
         ubuntu-terminal-app (>= ${source:Version}),
         ubuntu-ui-toolkit-autopilot,
Description: Autopilot tests for Terminal Application
 This package contains the autopilot tests for the Terminal

## ubuntu-terminal-app 0.7.218

=== debian/changelog ===
ubuntu-terminal-app (0.7.218) yakkety; urgency=medium

  [ Michael Sheldon ]
  * Add transitional packages for qml-module renaming. (LP: #1628781)

 -- Luke Yelavich <themuso@ubuntu.com>  Fri, 30 Sep 2016 12:54:32 +1000

=== debian/control ===
--- 
+++ 
@@ -30,15 +30,45 @@
 Description: Terminal application
  Core Terminal application
 
+Package: qtdeclarative5-qmltermwidget1.0
+Architecture: any
+Multi-Arch: same
+Depends: qml-module-qmltermwidget1.0,
+         ${misc:Depends},
+         ${shlibs:Depends},
+         ${misc:Pre-Depends},
+Description: Transitional dummy package for QMLTermWidget QML plugin.
+ This package contains the QMLTermWidget terminal emulator plugin
+ for Qt Qml.
+ .
+ This is a transitional dummy package for qml-module-qmltermwidget1.0
+ which can be safely removed.
+
 Package: qml-module-qmltermwidget1.0
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          ${misc:Pre-Depends},
+Breaks: qtdeclarative5-qmltermwidget1.0 (<< 0.7~)
+Replaces: qtdeclarative5-qmltermwidget1.0 (<< 0.7~)
 Description: QMLTermWidget QML plugin.
  This package contains the QMLTermWidget terminal emulator plugin
  for Qt Qml.
+
+Package: qtdeclarative5-pamauthentication0.1
+Architecture: any
+Multi-Arch: same
+Depends: qml-module-qmltermwidget1.0,
+         ${misc:Depends},
+         ${shlibs:Depends},
+         ${misc:Pre-Depends},
+Description: Transitional dummy package for PAM authentication QML plugin
+ This package contains a plugin that enables QML apps to do
+ password authentication via the PAM API.
+ .
+ This is a transitional dummy package for qml-module-pamauthentication0.1
+ which can be safely removed.
 
 Package: qml-module-pamauthentication0.1
 Architecture: any
@@ -46,6 +76,8 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          ${misc:Pre-Depends},
+Breaks: qtdeclarative5-pamauthentication0.1 (<< 0.7~)
+Replaces: qtdeclarative5-pamauthentication0.1 (<< 0.7~)
 Description: PAM authentication QML plugin
  This package contains a plugin that enables QML apps to do
  password authentication via the PAM API.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DCLICK_MODE=OFF

## ubuntu-terminal-app 0.7.218ubuntu1

=== CMakeLists.txt ===
project(com.ubuntu.terminal C CXX)
cmake_minimum_required(VERSION 2.8.9)
find_program(INTLTOOL_MERGE intltool-merge)
find_program(INTLTOOL_EXTRACT intltool-extract)

set(CMAKE_AUTOMOC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-permissive -pedantic -Wall -Wextra -fPIC")

# Standard install paths
include(GNUInstallDirs)

option(INSTALL_TESTS "Install the tests on make install" on)
option(CLICK_MODE "Installs to a contained location" on)

set(APP_NAME terminal)
set(DESKTOP_FILE "${PROJECT_NAME}.desktop")
set(APP_HARDCODE ubuntu-terminal-app)
set(MAIN_QML ubuntu-terminal-app.qml)
set(ICON_FILE terminal64.png)
set(AUTOPILOT_DIR ubuntu_terminal_app)
set(EXEC "${APP_NAME}")
set(UBUNTU_MANIFEST_PATH "manifest.json.in" CACHE INTERNAL "Relative path to the manifest file")

if(CLICK_MODE)
    if(NOT DEFINED BZR_SOURCE)
        set(BZR_SOURCE "lp:${APP_HARDCODE}")
        message("-- Setting BZR_SOURCE to ${BZR_SOURCE}")
    endif(NOT DEFINED BZR_SOURCE)
    # Find out the architecture for package building
    # to determine the plugin's installation path
    execute_process(
        COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
        OUTPUT_VARIABLE ARCH_TRIPLET
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    set(CMAKE_INSTALL_PREFIX /)
    set(CMAKE_INSTALL_BINDIR /)
    set(DATA_DIR /)
    set(DESKTOP_DIR ${DATA_DIR})
    set(ICON ${ICON_FILE})
    set(QT_IMPORTS_DIR "/lib/${ARCH_TRIPLET}")
    set(BIN_DIR /lib/${ARCH_TRIPLET}/bin)
    if(NOT BZR_REVNO)
      execute_process(
        COMMAND bzr revno
        OUTPUT_VARIABLE BZR_REVNO
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        OUTPUT_STRIP_TRAILING_WHITESPACE
      )
    endif(NOT BZR_REVNO)

    execute_process(
      COMMAND dpkg-architecture -qDEB_HOST_ARCH
      OUTPUT_VARIABLE CLICK_ARCH
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json terminal.apparmor DESTINATION ${CMAKE_INSTALL_PREFIX})

    # make the click files visible in qtcreator
    file(GLOB CLICK_FILES
         RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
         *.json *.json.in *.apparmor)

    add_custom_target(com_ubuntu_terminal_CLICKFiles ALL SOURCES ${CLICK_FILES})
else(CLICK_MODE)
    execute_process(
        COMMAND qmake -query QT_INSTALL_QML
        OUTPUT_VARIABLE QT_IMPORTS_DIR
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    set(DATA_DIR ${CMAKE_INSTALL_DATADIR}/${APP_NAME})
    set(ICON ${CMAKE_INSTALL_PREFIX}/${DATA_DIR}/${ICON_FILE})
    set(DESKTOP_DIR ${CMAKE_INSTALL_DATADIR}/applications)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/terminal.1 DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1)
endif(CLICK_MODE)

file(GLOB_RECURSE I18N_SRC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/po
     *.qml *.js *.cpp *.h)
list(APPEND I18N_SRC_FILES ${DESKTOP_FILE}.in.in.h)
list(SORT I18N_SRC_FILES)

file(GLOB SRC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     *.qml *.js *.png *.js)
install(FILES ${SRC_FILES}
    DESTINATION ${DATA_DIR})

configure_file(${DESKTOP_FILE}.in.in ${DESKTOP_FILE}.in)

add_custom_target(${DESKTOP_FILE} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE}..."
    COMMAND LC_ALL=C ${INTLTOOL_MERGE} -d -u ${CMAKE_SOURCE_DIR}/po ${DESKTOP_FILE}.in ${DESKTOP_FILE}
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
    DESTINATION ${DESKTOP_DIR})

# Tests
enable_testing()

add_subdirectory(po)
add_subdirectory(tests)
add_subdirectory(src)

=== po/CMakeLists.txt ===
include(FindGettext)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN ${PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)
file(GLOB PO_FILES *.po)

add_custom_target(${POT_FILE} ALL
    COMMENT "Generating translation template..."
    COMMAND ${INTLTOOL_EXTRACT} --update --type=gettext/ini
        --srcdir=${CMAKE_SOURCE_DIR} ${DESKTOP_FILE}.in.in
    COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
        -D ${CMAKE_CURRENT_SOURCE_DIR}
        -D ${CMAKE_CURRENT_BINARY_DIR}
        --from-code=UTF-8
        --c++ --qt --add-comments=TRANSLATORS
        --keyword=tr --keyword=tr:1,2 --keyword=N_
        --package-name='${PROJECT}'
        --copyright-holder='Canonical Ltd.'
        ${I18N_SRC_FILES}
    COMMAND ${CMAKE_COMMAND} -E copy ${POT_FILE} ${CMAKE_CURRENT_SOURCE_DIR})

foreach(PO_FILE ${PO_FILES})
    get_filename_component(LANG ${PO_FILE} NAME_WE)
    gettext_process_po_files(${LANG} ALL PO_FILES ${PO_FILE})
    set(INSTALL_DIR ${CMAKE_INSTALL_LOCALEDIR}/${LANG}/LC_MESSAGES)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.gmo
            DESTINATION ${INSTALL_DIR}
            RENAME ${DOMAIN}.mo)
endforeach(PO_FILE)

=== src/plugin/CMakeLists.txt ===
include(FindPkgConfig)
find_package(Qt5Core)
find_package(Qt5Qml)
find_package(Qt5Quick)
find_package(Qt5Widgets)

add_subdirectory(qmltermwidget)
add_subdirectory(pamauthentication)

=== src/plugin/pamauthentication/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
)

set(PLUGIN_DIR com/ubuntu/PamAuthentication)

set(pamauthentication_SRCS
    pamauthentication.cpp
    pamauthentication.h
    pamauthentication_plugin.cpp
    pamauthentication_plugin.h
)

add_library(PamAuthentication MODULE
    ${pamauthentication_SRCS}
)

target_link_libraries(PamAuthentication pam)

qt5_use_modules(PamAuthentication Gui Qml Quick Widgets DBus)

# Copy the plugin, the qmldir file and other assets to the build dir for running in QtCreator
if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
    add_custom_command(TARGET PamAuthentication POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
        COMMENT "Creating plugin directory layout in the build directory"
        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/qmldir ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
        COMMENT "Copying the qmldir file to the build directory"
        COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:PamAuthentication> ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
        COMMENT "Copying the plugin binary to the build directory"
    )
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

# Install plugin file
install(TARGETS PamAuthentication DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})
install(FILES qmldir DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})

=== src/plugin/qmltermwidget/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR} lib src
)

set(PLUGIN_DIR QMLTermWidget)
add_definitions(-DHAVE_POSIX_OPENPT -DHAVE_SYS_TIME_H -DHAVE_UPDWTMPX)
add_definitions(-DQ_WS_UBUNTU)

set(qmltermwidget_SRCS
    src/ksession.h
    src/ksession.cpp
    src/qmltermwidget_plugin.h
    src/qmltermwidget_plugin.cpp
    lib/BlockArray.h 
    lib/CharacterColor.h 
    lib/Character.h 
    lib/ColorScheme.h 
    lib/ColorTables.h 
    lib/DefaultTranslatorText.h 
    lib/Emulation.h 
    lib/ExtendedDefaultTranslator.h 
    lib/Filter.h 
    lib/History.h 
    lib/HistorySearch.h 
    lib/KeyboardTranslator.h 
    lib/konsole_wcwidth.h 
    lib/kprocess.h 
    lib/kptydevice.h 
    lib/kpty.h 
    lib/kpty_p.h 
    lib/kptyprocess.h 
    lib/LineFont.h 
    lib/Pty.h 
    lib/Screen.h 
    lib/ScreenWindow.h 
    lib/Session.h 
    lib/ShellCommand.h 
    lib/TerminalCharacterDecoder.h 
    lib/TerminalDisplay.h 
    lib/tools.h 
    lib/Vt102Emulation.h 
    lib/BlockArray.cpp 
    lib/ColorScheme.cpp 
    lib/Emulation.cpp 
    lib/Filter.cpp 
    lib/History.cpp 
    lib/HistorySearch.cpp 
    lib/KeyboardTranslator.cpp 
    lib/konsole_wcwidth.cpp 
    lib/kprocess.cpp 
    lib/kpty.cpp 
    lib/kptydevice.cpp 
    lib/kptyprocess.cpp 
    lib/Pty.cpp 
    lib/Screen.cpp 
    lib/ScreenWindow.cpp 
    lib/Session.cpp 
    lib/ShellCommand.cpp 
    lib/TerminalCharacterDecoder.cpp 
    lib/TerminalDisplay.cpp 
    lib/tools.cpp 
    lib/Vt102Emulation.cpp
)

add_library(qmltermwidget MODULE
    ${qmltermwidget_SRCS}
)

qt5_use_modules(qmltermwidget Gui Qml Quick Widgets)

# Copy the plugin, the qmldir file and other assets to the build dir for running in QtCreator
if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR})
    add_custom_target(qmltermwidget-qmldir ALL
        COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/src/qmldir ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
        DEPENDS ${QMLFILES}
    )
    add_custom_target(qmltermwidget-layouts-schemes ALL
        COMMAND cp -a ${CMAKE_CURRENT_SOURCE_DIR}/lib/color-schemes ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
        COMMAND cp -a ${CMAKE_CURRENT_SOURCE_DIR}/lib/kb-layouts ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
        DEPENDS ${QMLFILES}
    )
    add_custom_command(TARGET qmltermwidget POST_BUILD
        COMMENT "Creating plugin directory layout in the build dir"
        COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:qmltermwidget> ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
        COMMENT "Copying to output directory"
    )
    add_custom_target(qmltermwidget-qmlfiles ALL
        COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/src/QMLTermScrollbar.qml ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN_DIR}
        DEPENDS ${QMLFILES}
    )
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")


install(TARGETS qmltermwidget DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})
install(FILES src/qmldir DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})
install(DIRECTORY lib/color-schemes DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})
install(DIRECTORY lib/kb-layouts DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})
install(FILES src/QMLTermScrollbar.qml DESTINATION ${QT_IMPORTS_DIR}/${PLUGIN_DIR})

=== debian/changelog ===
ubuntu-terminal-app (0.7.218ubuntu1) yakkety; urgency=medium

  * Make the .desktop file be NotShowIn=Unity. This will prevent two
    applications called "Terminal" from showing up in the Unity 7 dash. This
    only works because Unity 8 doesn't respect the NotShowIn key at the
    current time - and therefore this solution is only a temporary measure for
    the 16.10 release and will be reverted shortly thereafter.

 -- Iain Lane <iain.lane@canonical.com>  Mon, 03 Oct 2016 17:50:29 +0100

## ubuntu-terminal-app 0.7.218ubuntu2

=== debian/changelog ===
ubuntu-terminal-app (0.7.218ubuntu2) yakkety; urgency=medium

  * Use OnlyShowIn=Unity8 instead. Apparently the situation changed and the
    previous formulation ("NotShowIn=Unity") started working on Unity 8, which
    hid the terminal there.

 -- Iain Lane <iain@orangesquash.org.uk>  Wed, 05 Oct 2016 14:27:03 +0100

## ubuntu-terminal-app 0.7.218+17.04.20170405.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,13 @@
-project(com.ubuntu.terminal C CXX)
+project(ubuntu-terminal-app C CXX)
 cmake_minimum_required(VERSION 2.8.9)
 find_program(INTLTOOL_MERGE intltool-merge)
 find_program(INTLTOOL_EXTRACT intltool-extract)
 
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-permissive -pedantic -Wall -Wextra -fPIC")
+
+# Enable QML debugging in debug builds
+set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DQT_QML_DEBUG ")
 
 # Standard install paths
 include(GNUInstallDirs)
@@ -62,13 +65,9 @@
          RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
          *.json *.json.in *.apparmor)
 
-    add_custom_target(com_ubuntu_terminal_CLICKFiles ALL SOURCES ${CLICK_FILES})
+    add_custom_target(ubuntu-terminal-app_CLICKFiles ALL SOURCES ${CLICK_FILES})
 else(CLICK_MODE)
-    execute_process(
-        COMMAND qmake -query QT_INSTALL_QML
-        OUTPUT_VARIABLE QT_IMPORTS_DIR
-        OUTPUT_STRIP_TRAILING_WHITESPACE
-    )
+    set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/qml")
     set(DATA_DIR ${CMAKE_INSTALL_DATADIR}/${APP_NAME})
     set(ICON ${CMAKE_INSTALL_PREFIX}/${DATA_DIR}/${ICON_FILE})
     set(DESKTOP_DIR ${CMAKE_INSTALL_DATADIR}/applications)
@@ -87,6 +86,11 @@
 install(FILES ${SRC_FILES}
     DESTINATION ${DATA_DIR})
 
+# Make non compiled files visible in qtcreator
+file(GLOB_RECURSE NON_COMPILED_FILES *.qml *.js *.py *.svg *.png *.in *.json *.desktop *.pot *.apparmor qmldir)
+add_custom_target(NON_COMPILED_TARGET ALL SOURCES ${NON_COMPILED_FILES})
+
+
 configure_file(${DESKTOP_FILE}.in.in ${DESKTOP_FILE}.in)
 
 add_custom_target(${DESKTOP_FILE} ALL

=== app/CMakeLists.txt ===
file(GLOB_RECURSE QML_SRCS *.qml *.js *.json *.png)

set(terminal_SRCS
    main.cpp
    fileio.cpp
    fonts.cpp
    shortcuts.cpp
    standardpaths.cpp
    ${QML_SRCS}
)

add_executable(terminal ${terminal_SRCS})

qt5_use_modules(terminal Gui Qml Quick Widgets)
target_link_libraries(terminal stdc++)

if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
add_custom_target(terminal-qmlfiles ALL
    COMMAND cp -r ${CMAKE_CURRENT_SOURCE_DIR}/qml ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${QMLFILES}
)
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

install(DIRECTORY qml DESTINATION ${DATA_DIR})
if(CLICK_MODE)
  install(TARGETS terminal DESTINATION ${BIN_DIR})
else()
  install(TARGETS terminal RUNTIME DESTINATION bin)
endif()

=== qtquicktest/CMakeLists.txt ===
find_program(XVFB_RUN_BIN xvfb-run)
if(NOT XVFB_RUN_BIN)
  message(FATAL_ERROR "Could not find xvfb-run, please install the xvfb package")
endif()
set(XVFB_RUN_CMD ${XVFB_RUN_BIN} -a -s "-screen 0 1024x768x24")

include(FindPkgConfig)
find_package(Qt5Core)

# copy qml test files to build directory
if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
add_custom_target(qmlTestFiles ALL
    COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/*.qml ${CMAKE_CURRENT_BINARY_DIR}
)
endif(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")

set(QTQUICK_TEST tst_qtquicktest)
add_executable(${QTQUICK_TEST} qtquicktest.cpp)
qt5_use_modules(${QTQUICK_TEST} Core Qml Quick Test QuickTest)
add_test(${QTQUICK_TEST} ${XVFB_RUN_CMD} ${CMAKE_CURRENT_BINARY_DIR}/${QTQUICK_TEST})
